#!/bin/sh

#########################################
# 
# script de gestion des imprimantes EAD
#
# normalement appelé via la commande sudo
#
#########################################

case "$1" in
	
completed)
	# travaux terminés
	if [ -z $2 ];then
		/usr/bin/lpstat -W completed all
	else
		/usr/bin/lpstat -W completed all | grep "^$2-"
	fi
;;
not-completed)
	# travaux en cours
	if [ -z $2 ];then
		/usr/bin/lpstat -W not-completed all
	else
		/usr/bin/lpstat -W not-completed all | grep "^$2-"
	fi
;;
details)
	# détails sur les travaux en cours
	/usr/bin/lpq -a
;;
restart)
	# redémarrage d'une impression
	if [ ! -z $2 ];then
		/usr/bin/lp -i $2 -H restart
	fi
;;
hold)
	# mise en attente d'une impression
	if [ ! -z $2 ];then
		/usr/bin/lp -i $2 -H hold
	fi
;;
cancel)
	# annulation d'une impression
	if [ ! -z $2 ];then
		/usr/bin/cancel $2
	fi
;;
all)
	# toutes les imprimantes
	/usr/bin/lpstat -l -p
;;
printer)
	# info sur une imprimante
	if [ ! -z $2 ];then
		/usr/bin/lpstat -l -p $2
	fi
;;
enable)
	# démarrer une imprimante
	if [ ! -z $2 ];then
		/usr/sbin/cupsenable $2
	fi
;;
disable)
	# arrêter une imprimante
	if [ ! -z $2 ];then
		/usr/sbin/cupsdisable $2
	fi
;;
#*)
#	r=2
#;;
esac
