#!/bin/bash
#MENU=Post installation pour CES
echo "CES : application des droits version 4 du 13/02/2006"

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=ces,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe ces"		
		/usr/share/eole/backend/ajout_groupe.py ces
fi

echo "permissions  du dossier commun"
/usr/bin/setfacl -k --set user::rwx,group::r-x,other::r-x /data/applidos/commun


echo "permissions  du dossier commun/ces"
/usr/bin/setfacl -m user::rwx,group::r-x,group:ces:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:mask::rwx,default:other::r-- /data/applidos/commun/ces


echo "permissions du dossier et des sous-dossiers commun/ces/fichiers"
for fic in `find /data/applidos/commun/ces/fichiers`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ces:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ces:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ces:rwx,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/ces/logiciel"
for fic in `find /data/applidos/commun/ces/logiciel`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ces:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ces:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

	/usr/bin/setfacl -m user::rwx,group::r--,group:cec:r-x,mask::rwx,other::r-- $fic
	fi

done


echo "permissions du dossier et des sous-dossiers commun/ces/cestmp"
for fic in `find /data/applidos/commun/ces/cestmp`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ces:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:ces:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:ces:rwx,mask::rwx,other::r-- $fic
	fi

done

echo "permissions du fichier commun/ces.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:ces:r-x,mask::rwx,other::r-- /data/applidos/commun/ces.bat 


echo "permissions du fichier commun/restces.bat"
/usr/bin/setfacl -m user::rwx,group::r--,group:ces:r-x,mask::rwx,other::r-- /data/applidos/commun/restces.bat 

echo "CES : application des droits terminée"

