#!/bin/bash
#MENU=Post installation pour DPSELENE
echo "DPSELENE : application des droits version 7 du 5/12/2007"

if [ -z "`ldapsearch -x -b 'ou=education,o=gouv,c=fr' '(objectclass=posixGroup)' | grep 'cn=selene,ou=local,ou=groupe'`" ] ; then 
		echo "Ajout du groupe selene"
		/usr/share/eole/backend/ajout_groupe.py selene
	fi

echo "permissions  du dossier winappli"
/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:mask::rwx,default:other::r-- /data/minedu/winappli


echo "permissions du dossier et des sous-dossiers winappli/selene"
for fic in `find /data/minedu/winappli/selene`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-- $fic

	fi
done

echo "Création du répertoire /data/minedu/winappli/men_inst/param/echecs si inexistant"
if [ ! -e "/data/minedu/winappli/men_inst/param/echecs" ]; 
then
	mkdir /data/minedu/winappli/men_inst/param/echecs
fi

echo "permissions du dossier et des sous-dossiers winappli/men_inst"
for fic in `find /data/minedu/winappli/men_inst`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-- $fic

	fi
done

echo "permissions du dossier et des sous-dossiers winappli/men_inst/param"
for fic in `find /data/minedu/winappli/men_inst/param`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ;  then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-- $fic
	fi
done


echo "permissions du dossier /winappli/men_inst/param/echecs/"
/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:rwx,default:mask::rwx,default:other::r-- /data/minedu/winappli/men_inst/param/echecs

echo "permissions des sous-dossiers winappli/men_inst/param/echecs"
for fic in `find /data/minedu/winappli/men_inst/param/echecs/*`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ;  then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-- $fic
	fi
done

echo "permissions du fichier winappli/men_inst/param/logfile.txt"
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-- /data/minedu/winappli/men_inst/param/logfile.txt

echo "permissions du dossier et des sous-dossiers winappli/men_ctrl"
for fic in `find /data/minedu/winappli/men_ctrl`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-- $fic

	fi
done

echo "permissions du dossier windata"
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:mask::rwx,default:other::r-- /data/minedu/windata

echo "permissions des sous-dossiers windata"
for fic in `find /data/minedu/windata/*`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r--,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r--,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ;  then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r--,mask::rwx,other::r-- $fic
	fi
done


echo "permissions du dossier et des sous-dossiers windata/echanges"
for fic in `find /data/minedu/windata/echanges`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:r-x,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ;  then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:r-x,mask::rwx,other::r-- $fic
	fi
done

echo "permissions du dossier et des sous-dossiers windata/echanges/selene"
for fic in `find /data/minedu/windata/echanges/selene`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ;  then
/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-- $fic
	fi
done

echo "permissions du dossier wintmp"

/usr/bin/setfacl -m user::rwx,group::r-x,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-x,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:rwx,default:mask::rwx,default:other::r-- /data/minedu/wintmp

echo "permissions des sous-dossiers wintmp"
for fic in `find /data/minedu/wintmp/* | grep -iv "/gfcwin"`
do
	if [ -d $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:rwx,mask::rwx,other::r--,default:user::rwx,default:group::r--,default:group:minedu:r--,default:group:selene:rwx,default:mask::rwx,default:other::r-- $fic

	elif [ -f $fic ] ; then

/usr/bin/setfacl -m user::rwx,group::r--,group:minedu:r--,group:selene:rwx,mask::rwx,other::r-- $fic

	fi
done

echo "DPSELENE : application des droits terminée"

