<?
/*
====================================================================================

          Module pour tout ce qui sert à l'authentification

====================================================================================

Ce module permet de valider ou de refuser une connexion, de logger les tentatives
de connexions, de crypter et d'ecrire le login et le password dans le fichier shadow


    Fonctions:

- string Authentificate($auth_login, $auth_password)
- array encrypt($login,$password)
- string writeShadow($newcrypt)

====================================================================================
*/



/*
====================================================================================
                       Fonction Authentification
====================================================================================

-
ce module gére l'authentification et l'accès à l'application  Eole admin
-

Fonctions

Authentificate
Encrypt
WriteShadow

-

Remarques:
Pas de remarques

-


====================================================================================
*/

/*

Authentificate
-
Résultat:
Retourne la valeur 1 ou 0 suivant si l'authentification a étét réussit oui ou non
-
Globales:
$password_path: le chemin du fichier ou il y a les infos pour l'authentification
$password_file: nom du fichier pour l'authentification
$path_log: chemin du fichier de log de connexion
$login_report: nom du fichier de log de connexion
File2String()
Add2File()
-
*/



 
function Authentificate($auth_login, $auth_password) 
{
   

   //authentification en passant par le fichier shadow
   
   global $password_path, $password_file ;

   //lecture du fichier shadow grace a la fonction file2string
   $file = $password_path.$password_file ; 
   $recupname = File2String($file) ;

   //on separe le login et le password qui sont relié par un ":"
   $recuplogin= explode( ":", $recupname);
   $username= $recuplogin[0];
   $password= $recuplogin[1];
   
   //cryptage du login et du password fournis dans la boite d'authentification
   $encrypted_username = crypt(substr($auth_login, 0, 8),"Za");
   $encrypted_username .= substr(crypt(substr($auth_login, 8, 8),"Za"),2,11);

   $encrypted_password = crypt(substr($auth_password, 0, 8),substr($encrypted_username,2,2));
   $encrypted_password .= substr(crypt(substr($auth_password, 8, 8),substr($encrypted_username,2,2)),2,11);
  
    
   global $path_log, $login_report ;
    $file = $path_log.$login_report ;
   //on ecrit dans le fichier login.log l'etat de la connexion, c a dire si elle a reussit ou echoué
   if  (($encrypted_username==$username) &&
	($encrypted_password==$password))  {
           
         
     $ladate = PrintDate() ;
     $msglog = $ladate."\n" ;
     $msglog .= "connexion" ;
    
     Add2file($msglog, $file) ;

      return 1 ;

    } else  {
     

      $ladate = PrintDate() ;
      $msglog = $ladate."\n" ;
      $msglog .= "la connexion a échouée" ;

      Add2File($msglog, $file) ;

      return 0 ;
    }

 }

/*
=======================================================================================================

                                             Fonction encrypt

=======================================================================================================

- string encrypt($login,$password)

- crypte les variables $login et $password

- paramètres:
   $login, $password

- valeur retournée:
  array login, password

- références globales:
  aucunes
  Utilisée par confirmation-des-changements-de-login.php  
=======================================================================================================
*/
// crypatge de mots de user et de mots de passe
function encrypt($login,$password)  {

    $encrypted_username = crypt(substr($login, 0, 8),"Za");
    $encrypted_username .= substr(crypt(substr($login, 8, 8),"Za"),2,11);

    $encrypted_password = crypt(substr($password, 0, 8),substr($encrypted_username,2,2));
    $encrypted_password .= substr(crypt(substr($password, 8, 8),substr($encrypted_username,2,2)),2,11);
    return array ("login" => $encrypted_username
		  ,"password" => $encrypted_password
		  ) ;
}


/*
=======================================================================================================

                                           Fonction writeShadow

=======================================================================================================

- string writeShadow

- ecrit le nouveau mot de pass dans le fichier Shadow

- paramètre:
  $newcrypt

- valeur retournée:
  aucunes, mais ecriture dans le fichier Shadow

- références globales:
  aucunes
  Utilisée par confirmation-des-changements--de-login.php
=======================================================================================================
*/


function writeShadow($newcrypt) {

  global $password_path, $password_file ;  

  $file = $password_path.$password_file ;
  $buffer = $newcrypt ; 
 
 //appel de la fonction string2file pour ecrire dans shadow  

  String2File($buffer,$file) ;
  
}

?>
