<?
/*
     =======================================================================

     librairie eole : librairie générale des fonctions de l'interface Eole Admin
        $Id: eole-lib.inc,v 1.1.1.1 2004/01/05 10:25:51 eole Exp $

     =======================================================================
     -
     génération de l'outil de navigation, du message d'alerte, etc...
     -
      Fonctions : 
      ServiceBoard
      SelectService
      DisplayMessage
      FailureTrace
      setFlag
      DisplayItem
      Navigation
      ShowCurrentScriptName
      FiltreCaracteresSpeciaux
      nb_Session
     -
      Remarques :
      aucune
     -

     =======================================================================
     */

require("image-lib.inc") ;
require("common-lib.inc") ;
//
/*
     =======================================================================

     génération du tableau de bord

     =======================================================================
*/

/*
ServiceBoard
-
génération du tableau de bord : affiche le statut (actif, inactif) de chaque service
-
Paramètres : 
$service_board // liste des services
$active_service // liste des services actifs  
$link_board  // liste des liens vers la page des services
-
Résultat : 
html, "table" du tableau de bord
-
Globales :
SelectService()
-
 */
function ServiceBoard(
		      $service_board
		      ,$active_service
		      ,$link_board
		      ) {

  $buffer = "" ;
  $buffer .= "<TABLE WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"4\" BORDER=\"0\">" ;

  foreach ($service_board as $val) {


    $boolean = $active_service[$val] ;
    $href = $link_board[$val] ;

    $buffer .= SelectService(
		       $val
		       ,$href
		       ,$boolean
		       // diode
		       ,$diode_width
		       ,$diode_height
		       ,$red_light
		       ,$green_light
		       ) ;

  }

  $buffer .= "</TABLE>\n";
  return $buffer ;
  
}

/*
SelectService
-
affiche le statut d'un seul service et sa diode associée
-
Paramètres :
$service // 
$href // 
$boolean // 
-
Résultat : 
string : html : une ligne de tableau
-
Globales :
$red_light, $green_light, $diode_width, $diode_height ;
ImageLink(), Image()
-
 */

function SelectService(
		       $service
		       ,$href
		       ,$boolean
		       ) {
  global $red_light, $green_light, $diode_width, $diode_height ;

  if ($boolean == 0) {
    $image_diode = ImageLink("diode",$red_light,$href,$diode_width,$diode_height) ;
  } else {
    $light = $green_light ;
    $image_diode  = Image("diode",$green_light,$diode_width,$diode_height) ;
  }

  $buffer = "<TR ALIGN=\"left\" VALIGN=\"top\"><TD WIDTH=\"2%\"><TR><TD>" ;
  $buffer .= $image_diode ;
  $buffer .= "</TD>" ;
  $buffer .= "<TD WIDTH=\"98%\" nowrap ALIGN=\"left\" VALIGN=\"middle\"><FONT SIZE=\"+0\" COLOR=\"#a0b3d1\"><B>" ;
  $buffer .= "<A HREF=\"".$href."\">".$service."</A>" ;
  $buffer .= "</B></FONT></TD></TR>" ;

  return($buffer) ;

 }
/*
     =======================================================================

     affichage du message d'alerte

     =======================================================================
*/

/*
DisplayMessage
-
affichage du message de prévention sur la page d'accueil
-
Paramètres :
aucun
-
Résultat :
string (message)
-
Globales :
$flag_failure
FailureTrace()
-
*/
function DisplayMessage() {
  
  global $flag_failure ;

  if ($flag_failure == 0) {
    $msg = "ATTENTION : certains services ne fonctionnent plus normalement" ;
    FailureTrace() ;
  } else {
    $msg = "Tous les services sont en état de marche" ;
  }
  return $msg ;
}
/*
FailureTrace
-
reporting des services défectueux
écrit dans un journal de trace à chaque fois 
qu'il y a détection d'un service défaillant
-
Paramètres : 
aucun
-
Résultat : 
aucun
-
Globales : 
$active_service, $error_log_service
PrintDate(), l()
-
*/
function FailureTrace() {

  global $active_service, $error_log_service ;

  $msg = PrintDate() ;
  
  foreach ($active_service as $key => $val) {
    if ($val == 0) {
      $msg .= "   le service $key ne fonctionne plus\n" ;
    }
  }

  l($msg,$error_log_service) ;
}

/*
setFlag
-
test de mise à jour de la variable globale flag_failure
-
Paramètres : 
aucun
-
Résultat
0 ou 1 
-
Globales :
$active_service, $flag_failure
-
*/
function setFlag() {

  global $active_service, $flag_failure ;

  if (in_array ("0", $active_service)){
    $flag_failure = 0 ;
  } else { 
    $flag_failure = 1 ;
  }
}

/*
     =======================================================================

     début de la génération du navigateur

     =======================================================================
*/

/*
DisplayItem
-
génère un lien de navigation
-
Paramètres :
$service_name // nom du service 
$service_explanation // explication qui figurera à la suite dans le navigateur
$service_link // liens de navigation
-
Résultat :
string - html - une ligne du navigator
-
Globales :
aucune
-
 */
function DisplayItem(
		     $service_name
		     ,$service_explanation
		     ,$service_link
		     )
{

  $buffer ="<TR><TD COLSPAN=\"3\" ALIGN=\"left\"><FONT COLOR=\"#8ea699\"><B>" ;
  $buffer .="<A HREF=".$service_link.">" ;
  $buffer .= $service_name ;
  $buffer .= "</A>" ;
  $buffer .= "</B><BR></FONT></TD></TR><TR><TD>&nbsp;&nbsp;</TD><TD ALIGN=\"right\"><FONT COLOR=\"#444444\" SIZE=\"-1\">" ;
  $buffer .= $service_explanation ;
  $buffer .="</FONT></TD><TD>&nbsp;&nbsp;</TD></TR><TR><TD>&nbsp;</TD></TR>" ;

  return $buffer ;
}

/*
Navigation
-
génère le navigateur
-
Paramètres : 
$navigator // liste des item de navigation
$link_service // vecteur de liens 
-
Résultat :
string - html - tableau de navigation
-
Globales :
DisplayItem()
-
 */
function Navigation($navigator,$link_service) {

  $buffer = "" ;
  $buffer .= "<TABLE WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"2\" BORDER=\"0\" ALIGN=\"right\">" ;
  foreach ($navigator as $keys => $values) {
    $service_link = $link_service[$keys] ;
    $buffer .= DisplayItem($keys,$values,$service_link) ;
  }
  $buffer .="</TABLE>" ;

  return $buffer ;

}

/*
     =======================================================================

     présentation de l'arborescence      

     =======================================================================
*/

/*
 ShowCurrentScriptName
-
permet l'afficher le nom de la page courante de manière 
à se repérer dans l'arborescence de navigation
-
Paramètres : 
aucun
-
Résultat :
string - nom de la page courante -
-
Globales :
$PHP_SELF
getScriptName()
-
*/
function ShowCurrentScriptName() {

  global $PHP_SELF ;

  $buffer = "" ;

  //  $buffer = "<A HREF=\"" ;
  // $buffer .= $PHP_SELF ;
  //  $buffer .="\">" ;
  $buffer .= getScriptName($PHP_SELF) ;
  //  $buffer .="</A>" ;

  return $buffer ;
}

/*
FiltreCaracteresSpeciaux
-
remplacement des carractères spéciaux pour récupérer les sorties shell
correctement et sans bizarreries
-
Paramètres :
$contenu // buffer sale
-
Résultat :
buffer propre
-
Globales : 
aucune
-
*/
function FiltreCaracteresSpeciaux($contenu) 
{
  
  $contenu = ereg_replace("([[:cntrl:]])*","",$contenu) ;
  $contenu = ereg_replace("(\[1\;32m)*","",$contenu) ;
  $contenu = ereg_replace("(\[0\;39m)*","",$contenu) ;
  $contenu = ereg_replace("(\[1\;31m)*","",$contenu) ;
  $contenu = ereg_replace("(\[1\;33m)*","",$contenu) ;
  $contenu = ereg_replace("(\[60G)*","",$contenu) ;

  return $contenu ;

}


/*
nb_Session
-
affiche le nombre de sessions utilisateurs en cours
-
Paramètres :
aucun
-
Résultat :
message (string)
-
Globales : 
get_dir
-
*/

function nb_Session() {

  // récupération des fichiers du répertoire d'enregistrement des sessions
  $rep = "/tmp/" ;
  $list = get_dir($rep) ;
  reset($list) ;

  // vecteur contenant les id de session
  $id_session = array() ;
  // filtre sur les noms de sessions
  foreach ( $list as $valeur )  
    {


      if ( ereg( "sess_" , $valeur ) && ( $valeur != "sess_0" ) )
	{

	  $id_session[] = $valeur ;
      
	} else  
	  {

	    // ne fait rien
	    
	  }

    }

  // génération du message de connexion utilisateur

  $nb_session = count($id_session) ;

  if ( $nb_session == 1 )  
    {

	$message =  "- utilisateur connecté - " ;

    } else  
      {

      $message = "Attention : <br>".$nb_session." sessions ouvertes !" ;
	
      }

      return $message ;
}

?>