
<?

class CInfo
{
	var $m_sName;
	var $m_iCount=0;
	var $m_sDate="";
	
	function CInfo($p_sName)
	{
		$this->m_sName=$p_sName;
	}
	
	function AddCount($p_sDate)
	{
		$this->m_iCount++;
		$this->m_sDate=$p_sDate;
	}

	
	function Format()
	{
		return $this->m_sName . "," . $this->m_sDate  . ","  . $this->m_iCount ;
	}
	
	function GetCount()
	{
		return $this->m_iCount;
	}
	
	function Assign(&$p_oTemplate)
	{
		$tDate=strtotime($this->m_sDate );
		$sTimestamp=strftime("%Hh%Mm",mktime (0, 0, time()-$tDate));
		$sDate=strftime("%d %B à %H:%M ",$tDate );
		$p_oTemplate->assign("DATE",$sDate);
		$p_oTemplate->assign("DELAY",$sTimestamp);
		$p_oTemplate->assign("NUMBER",$this->m_iCount);		
	}
	
}


class CAppsInfo extends CInfo
{
	function CAppsInfo($p_sName)
	{
		$this->CInfo($p_sName);
	}
	
	function Assign(&$p_oTemplate)
	{
		parent::Assign($p_oTemplate);
		$p_oTemplate->assign("APPLICATION",$this->m_sName);
	}
	
}

// =======================================================================================
class CFilesInfo extends CInfo
{

	var $m_sMode="";
	
	function CFilesInfo($p_sFilename,$p_sMode)
	{
		$this->CInfo($p_sFilename);
		$this->m_sMode=$p_sMode;
	}
	
	function Format()
	{
		return $this->m_sFilename . ","  . $this->m_sMode . "," . $this->m_sDate  . ","  . $this->m_iCount ;
	}
	
	function Assign(&$p_oTemplate)
	{
		parent::Assign($p_oTemplate);
		$p_oTemplate->assign("IMAGE",$this->m_sMode);
		$p_oTemplate->assign("FILENAME",$this->m_sName);
	}
}
// ===========================================================================================


class CSmbStatus
{

	var $m_arUsers;
	var $m_arUserPid;
	var $m_arUserComputer;
	var $m_arComputerPid;
	var $m_arFiles;
	var $m_arApplications;
	var $m_arUserApplications;
	// CL : AJOUT 02/06/2004 : Pour Affichage de l'@IP a c��du nom netbios de la machine
	var $m_arComputerIp;
	
	var $m_arMapShared= array (
							 "/home/workgroups/donnees/" => "donnees",
							 "/data/applidos/" => "applidos",
							 "/data/donnees/" => "donnees",
							 "/home/" => "perso",
							"/var/www/" => "ead");

	var $m_arMapApplication = array(
							  "gep.exe" => "Gep",
							  "sco" => "base élèves",
							  "abs" => "Abscences",
							  "aff" => "Affectations",
							  "brs" => "Bourses",
							  "cng" => "Congé",
							  "exl" => "Extractions personnalisées",
							  "get" => "Gestion emploi du temps",
							  "gin" => "Gestion individuelle",
							  "lia" => "Liaison",
							  "nom" => "Nomanclature",
							  "not" => "Donn�s p�agogiques",
							  "sco" => "Base ��es",
							  "sts" => "Structures et services",
							  "uti" => "Utilitaire",
							  "putty" => "Putty",
							  "A_D" => "LanBooster");
	
	

    function GetIp($p_sIp)
	{
		return $this->m_arComputerIp[$p_sIp];
	}



	//  function : GetArrayUser
	//  return an array of coonected user
	function GetArrayUser() 
	{
		return $this->m_arUserPid;
	}
	
	function GetNumberOfConnectedUser()
	{
		$array=$this->GetArrayUser();
		if (!is_array($array)) return 0;
		return count ($array);
	}
	
	// function : GetListOfComputersForUser
	// arg 1 : $p_sUser : represents a user
	// return an array of computers where the user is connected 
	function GetArrayOfComputersForUser($p_sUser)
	{
		if (!is_array($this->m_arUserComputer[$p_sUser]))
		{
			$array=explode(",",$this->m_arUserComputer[$p_sUser]);
			$this->m_arUserComputer[$p_sUser]=array_unique($array);
		}
		return $this->m_arUserComputer[$p_sUser];
	}
	
	// function : GetComputersForUser
	// arg 1 : $p_sUser : represents a user
	// return a string with comma separated of computers where the user is connected to
	function GetComputersForUser($p_sUser)
	{
		$array=$this->GetArrayOfComputersForUser($p_sUser);
		return implode(",",$array);
	}
	
	// function : GetListOfPidForUser
	// arg 1 : $p_sUser : represents a user
	// return an array of PID used by an user
	function GetListOfPidForUser($p_sUser)
	{
		return explode(",",$this->m_arUserPid[$p_sUser]);
	}	
	
	// function : GetApplicationsForUser
	// arg 1 : $p_sUser : represents a user
	// arg 2 : $p_sComputer : represents a computer
	// return an array of APPLICATION used by an user on a computer
	function GetApplicationsForUser($p_sUser,$p_sComputer)
	{
                ## FIXME ##
                return array();
		$array=$this->GetListOfPidForUser($p_sUser);
                $arResult = array();
		while (list($key,$sPid) = each ($array))
		{
			if ((!$this->m_arComputerPid[$p_sComputer][$sPid]) && ($p_sComputer!=false)) continue;
			$arResult=array_merge($this->m_arApplication[$sPid],$arResult);
		}
		if (!is_array($arResult)) return false;
		
		ksort ($arResult,SORT_STRING);
		return $arResult;
	}
	
	function HasApplications($p_sUser)
	{
		$array=$this->GetApplicationsForUser($p_sUser,false);
		if ($array==false) return false;
		return count($array)!=0;	
	}
	
	// function : GetFilesForUser
	// arg 1 : $p_sUser : represents a user
	// arg 2 : $p_sComputer : represents a computer
	// return an array of FILES used by an user on a computer
	function GetFilesForUser($p_sUser,$p_sComputer)
	{
		$array=$this->GetListOfPidForUser($p_sUser);
		$arResult=Array();
		$bFile=false;
		while (list($key,$sPid) = each ($array))
		{
			
			if (!$this->m_arComputerPid[$p_sComputer][$sPid]) continue;
			if (!is_array($this->m_arFiles[$sPid])) continue;
			$arResult=array_merge($this->m_arFiles[$sPid],$arResult);

		}
		
		if (is_array($arResult)) 
			ksort ($arResult,SORT_STRING);

		return $arResult;
	}
	

	function GetFormattedFilename($p_sFilename)
	{	
		$sNewFilename=str_replace($m_arsPath,$m_arsShared,$p_sFilename);
		return $sNewFilename;
	}
	
	// Format a line extracted from smbstatus
	function GetDataFromLine($p_sLine,$p_iColumn)
	{
		$iColumn=0;
		$iIndex=0;
		$sResult="";
		$sCurrent="";
		$p_sLine= $p_sLine . " ";
		$iCount=strlen($p_sLine);
		//echo "ParseLine : $p_sLine ($iCount)<br>";
		while ($iIndex<$iCount)
		{
			$sChar=substr($p_sLine,$iIndex,1);
			if (($sChar)!=" ") 
			{
				$sCurrent .= $sChar;
			}
			else if ($sCurrent != "" )
			{
				$sResult  .= $sCurrent . ",";
				$sCurrent = "";
				while (substr($p_sLine,$iIndex++,1)!=" ");
				$iIndex--;
				$iColumn++;
				//echo "$iColumn==$p_iColumn<br>";
				if ($iColumn==$p_iColumn) 
				{
					$sResult  .= substr($p_sLine,$iIndex,$iCount-$iIndex-2);	
					$iIndex=$iCount+1;
				}
			}
			$iIndex++;
		}
		//echo $sResult."$iIndex<br>";
		return explode(",",$sResult);
	}

	// =======================================================================
	// Retrieve shares and users 	
	function retrieveUsers(&$p_oLines)
	{
		$iCurrenline=0;
                $arColumns=array("pid","username","group","machine","ip");
		$currentColumn=current($arColumns);
		$iCountConnection=0;
		$bStop=false;

		while (list ($key, $val) = each ($p_oLines)) 
		{
			if ($bStop==true) break;
			$iCurrenline++;
			// Skip the 5 first lines
			if ($iCurrenline<5) continue;
			
			//echo $key,$val."<br>";
			//continue;

			// Parse the current line
			// and add retrieve data to the array $arInformations
			$line=$this->GetDataFromLine($val,6);
			

			$sCurrentPid=$line[0];
			$sCurrentUser=$line[1];
			$sCurrentMachine=$line[3];
			$sCurrentIp=$line[4];

			if ($sCurrentPid=="Service")	break;
			if (($sCurrentUser=="") || ($sCurrentUser=="nobody") || ($sCurrentUser=="apache"))	continue;

			$this->m_arUsers[$sCurrentUser]["id"]++;
			$this->m_arUserPid[$sCurrentUser] .= "," . $sCurrentPid;
			$this->m_arUserComputer[$sCurrentUser] .= $sCurrentMachine . ","; 
			$this->m_arComputerPid[$sCurrentMachine][$sCurrentPid]=true;
			
			reset($arColumns);
			$currentColumn=current($arColumns);	
			while ( list($columnKey,$columnValue) = each ($line)) 
			{
				//if ($columnValue=="") continue;
				//if (($sCurrentUser=="nobody") || ($sCurrentUser=="apache")) continue;
					
				// Verify the end of Array
				if ($currentColumn=="pid") {
					if (($columnValue=="Service") || ($columnValue=="No")) {$bStop=true;break;}
				}
				
				// Create a new user entry
				/*if ($currentColumn=="username") 
				{
					 echo "Ajout du user [$columnValue].<br>";
					 $this->m_arUsers[$columnValue]["id"]++;  // If is the uid column we count the connection for this uid
					 $sCurrentUser=$columnValue;
				} 
				// Coumn PID : Build a list of PID used by the currentUser 
				else if ($currentColumn=="pid") 
				{
				  echo "Ajout du pid $columnValue pour le user $sCurrentUser <br>" ;
				  $this->m_arUserPid[$sCurrentUser] .= "," . $columnValue; 
				  $sCurrentPid=$columnValue;
				}
				// Column MACHINE : Build a list of PId used by the currentUser 
				else if ($currentColumn=="machine") 
				{
				  $this->m_arUserComputer[$sCurrentUser] .= $columnValue . ","; 
				  $this->m_arComputerPid[$columnValue][$sCurrentPid]=true;
				  // CL : 02/06/2004 
				  $sCurrentMachine=$columnValue;
				} */
				
				// CL : 02/06/2004 
				// Column IP : Build a list of PId used by the currentUser 
				else if ($currentColumn=="ip") 
				{
					$this->m_arComputerIp[$sCurrentMachine]=substr($columnValue,1,strlen($columnValue)-2);
				}
				
				$currentColumn=next($arColumns);
			}
		}
		
		if (is_array($this->m_arUserPid)) 
			ksort($this->m_arUserPid, SORT_STRING);
			
		if (is_array($this->m_arUserComputer)) 
		ksort($this->m_arUserComputer, SORT_STRING);
			
	}
	// =================================================================================
	
	// =================================================================================
	// Retrieve locked files	
	function RetrieveFiles(&$p_oLines)
	{
		$iCurrenline=0;
		$bOk=false;
		while (list ($key, $val) = each ($p_oLines)) 
		{
			

			list($pid,$uid,$mode,$access,$rw,$lock,$fullname)=$this->GetDataFromLine($val,6);
			if (trim($fullname)=="") continue;
			
			if (trim($pid)=="Pid") {$bOk=true;continue;}
			if ($bOk==false) continue;
	
			//echo "$pid,$mode,$access,$rw,$lock,$fullname<br>";
		
			$iCurrenline++;
			$name=substr($fullname,0,strlen($fullname)-24); // 24 represent the lenght of the date
			$date=substr($fullname,strlen($fullname)-24,24); // date format ddd MMM dd HH:MM:SS YYYY
			
			sscanf($date,"%s %s %d %d:%d:%d",$day,$month,$day,$hour,$minute,$second);
			$date=$month . " " . $day . " " . date("Y") . " " . $hour . ":" . $minute . ":" . $second;
			
			// Application 
			reset($this->m_arMapApplication);
			$bAppli=false;
			while (list ($k, $app) = each ($this->m_arMapApplication)) 
			{
				//echo $k . " -> " . $app . "<br>"; 
				if ((strpos($name,$k)!== false)  && (strpos($name,"exe")!== false))
				{ 
					//echo $name . "<br>";
					//echo $k;
				   	if (!$this->m_arApplication[$pid][$app])
				    	{				
					    $this->m_arApplication[$pid][$app]=new CAppsInfo($app);
					}
					$this->m_arApplication[$pid][$app]->AddCount($date);
				    $bAppli=true;
				    break;
				}
			}
			
			if ($bAppli) continue;
		
			// Files
			reset($this->m_arMapShared);
			while (list ($k, $app) = each ($this->m_arMapShared)) 
			{
				//echo "$k<br>";
				if ((strpos($name,$k)!==false ))
				{ 
					$name = str_replace($k,"<b>[ " . $app  . " ]</b> ",$name);
					//echo "$k.$name<br>";
					break;
				}
			}
			
			if (!$this->m_arFiles[$pid][$name])
			{		
				//echo "Creation d'un CFile Info $rw,$name,$pid <br>";		
				$this->m_arFiles[$pid][$name]=new CFilesInfo($name,$rw);
			}
			
			$this->m_arFiles[$pid][$name]->AddCount($date);
			
			
		}		
	}
	
	function CSmbStatus()
	{
	
		// ========================================================================
		// Get Data from the smbstatus command line
		$r=exec("smbstatus ",$oLines);
		
		$this->retrieveUsers($oLines);
		$this->retrieveFiles($oLines);

		//print_r($this->m_arUserPid);
		
	// =================================================================================
	}
}
?>
